
import os

import gobject , gtk
import cairo

from math import *

class CairoWidget(gtk.DrawingArea):
	def __init__(self):
		super(CairoWidget, self).__init__()
		self.connect("expose_event", self.expose)
		self.elems = []
		self.ctx = None

	def move_up(self):
		elem = self.elems.pop()
		self.elems.insert(0, elem)
		self.redraw()

	def move_down(self):
		elem = self.elems.pop(0)
		self.elems.append(elem)
		self.redraw()


	def __draw_image(self, context, pixbuf, w, h, y, x ):
		#print w,h,x,y,i,r
		context.set_source_pixbuf(
			pixbuf.scale_simple( int(w), int(h), gtk.gdk.INTERP_BILINEAR),
			int(x), int(y) )
		context.paint()
		return 
		context.set_source_rgb(0, 0, 0)
		context.move_to(x, 10)
		layout = context.create_layout()
		layout.set_markup("<span size=\"x-small\">%d</span>"%i)
		context.show_layout(layout)
		
	def expose(self, widget, event):
		ctx = widget.window.cairo_create()
		self.ctx = ctx
		# set a clip region for the expose event
 		ctx.rectangle(event.area.x, event.area.y,
                                 event.area.width, event.area.height)
		ctx.clip()
		ctx.set_source_rgb(255, 255, 255)
 		ctx.rectangle(event.area.x, event.area.y,
                                 event.area.width, event.area.height)
		ctx.fill()
		ctx.set_source_rgb(0, 0, 0)
 		ctx.rectangle(event.area.x, event.area.y,
                                 event.area.width, event.area.height)
		ctx.set_line_width(5)
		ctx.stroke()
		self.draw(ctx,event)
		return False

	def draw(self, context,event):
		elems = self.elems[:]
		len_elems = len(elems)

		offset_x = 10
		offset_y = 25
		moy_height = 100
		size = 70

		tmp = map(lambda i: round(1+sin(radians(i*90/len_elems)),4), range(0,len_elems))
		tmp.reverse()
		tmp2 = []
		[ tmp2.append(size*r) for r in tmp ]
		a = round(max(tmp2)/float(size),4)
		print a,tmp
		#tmp.pop(tmp.index(a))
		print event.area.width, sum(tmp), max(tmp2)
		deca = event.area.width/sum(tmp)
		print deca
		
		prepare_elems = []
		y = 0
		for i,(pixbuf, text) in enumerate(elems):
			if i > len_elems/2:
				r = 1+sin(radians( ( len_elems -1 - i )*90/len_elems) )
				y = y + r*deca + w - size*r
			else:
				r = 1+sin(radians(i*90/len_elems))
				y = y + r*deca	

			w = size*r
			h = size*r
			x = offset_x
			
			if i > len_elems/2:
				prepare_elems.insert(0,(context,pixbuf,w,h,x,y))
			else:
				prepare_elems.append((context,pixbuf,w,h,x,y))
				
			#print i,len_elems-1 - i, r, y, deca ,w ,h

		for elems in prepare_elems:
			self.__draw_image(*elems)
		
		#context.transform()
		#context = cairo.Context()
		"""context.move_to(300, 300)
		context.set_source_rgb(0, 0, 0)
		layout = context.create_layout()
		layout.set_markup("<span size=\"small\">"+text+"</span>")
		context.show_layout(layout)
		context.stroke()"""


	def add_elem(self, filename, text):
		#surface = cairo.ImageSurface.create_from_png(filename)
		self.elems.append( (filename, text) )

	def redraw(self):
		rect = self.get_allocation()
		self.window.invalidate_rect(rect, True )
		self.window.process_updates(True)

def on_scroll(e, ev, w):
	if ev.direction in [gtk.gdk.SCROLL_UP, gtk.gdk.SCROLL_LEFT]:
		w.move_up()
	else:
		w.move_down()

def main():
	window = gtk.Window()
	w = CairoWidget()
	path = "/home/prout/.listen/cover/"
	for filename in os.listdir(path)[:21]:
		try:
			img= gtk.gdk.pixbuf_new_from_file_at_size(path+filename, 40,40)
		except gobject.GError:
			pass
		else:
			w.add_elem( img,filename )
	e = gtk.EventBox()
	e.connect("scroll-event", on_scroll, w)
	e.add(w)
	window.add(e)
	window.connect("destroy", gtk.main_quit)
	window.set_size_request(600, 400)
	window.show_all()
	gtk.main()

if __name__ == "__main__":
    main()


